
#include <string.h>
#include <jni.h>
#include <stdlib.h>
#include <stdio.h>
#include <android/log.h>
 #define  LOGD(...)  __android_log_print(ANDROID_LOG_DEBUG,"jni",__VA_ARGS__)


#ifdef __cplusplus
extern "C" {
#endif

static const char* className = "com/example/hellojni/MainActivity";
JNIEXPORT jstring JNICALL stringFromJNI(JNIEnv* env, jclass clazz)
{
    //return env->NewStringUTF(env, "Hello form JNI!");
    return env->NewStringUTF("hello world returned.");
}

int native_max(JNIEnv* env, jclass clazz, int a, int b)
{
   return  (a > b ? a:b);
}

static JNINativeMethod gMethods[] = {
    { "stringFromJNI", "()Ljava/lang/String;", (void *)stringFromJNI },
    { "max", "(II)I", (void *)native_max },
};

// This function only registers the native methods, and is called from JNI_OnLoad
JNIEXPORT int JNICALL register_location_methods(JNIEnv *env)
{
    jclass clazz;

    /* look up the class */
    clazz = env->FindClass(className );
    //clazz = env->FindClass(env, className);
    if (clazz == NULL) {
    	LOGD("Can't find class %s\n", className);
        return -1;
    }

    LOGD("register native methods");

    /* register all the methods */
    //if ((*env)->RegisterNatives(env, clazz, gMethods, sizeof(gMethods) / sizeof(gMethods[0])) != JNI_OK)
    if (env->RegisterNatives(clazz, gMethods, sizeof(gMethods) / sizeof(gMethods[0])) != JNI_OK)
    {
    	LOGD("Failed registering methods for %s\n", className);
        return -1;
    }

    /* fill out the rest of the ID cache */
    return 0;
}

jint JNI_OnLoad(JavaVM* vm, void *reserved)
{
    JNIEnv* env = NULL;
    jint result = -1;

    LOGD("%s: +has loaded", __FUNCTION__);

    // for c
    //if ((*vm)->GetEnv(vm, (void**) &env, JNI_VERSION_1_4) != JNI_OK) {
    // for c++
    if( vm->GetEnv((void**) &env, JNI_VERSION_1_4) != JNI_OK) {
    	LOGD("ERROR: GetEnv failed.\n");
        return result;
    }

    if( register_location_methods(env) < 0 )
    {
    	LOGD("ERROR: register location methods failed.\n");
        return result;
    }
    return JNI_VERSION_1_4;
}

void JNI_OnUnload(JavaVM* vm, void *reserved)
{
    return;
}

#ifdef __cplusplus
}
#endif
